<?xml version="1.0" encoding="UTF-8"?>
<!--
   Copyright 2010 Anyware Services

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
   -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                              xmlns:i18n="http://apache.org/cocoon/i18n/2.1"
                              xmlns:encoder="org.ametys.runtime.util.URLEncoder"
                              xmlns:pathEncoder="org.ametys.workspaces.repository.explorer.URLPathEncoder"
                              exclude-result-prefixes="encoder pathEncoder">
                  
    <xsl:import href="resource://org/ametys/runtime/kernel/stylesheets/plugins.xsl"/>
   	<xsl:import href="template.xsl"/> 
   	
    <xsl:param name="debug-mode">true</xsl:param>
    
   	<xsl:template name="workspace-body">

   	</xsl:template> 
    
    <xsl:param name="workspaceName"/>
	
    <xsl:template name="workspace-title"/>
    
    <xsl:template name="workspace-head">
    </xsl:template>

    <xsl:template name="workspace-script">
    	<script type="text/javascript">var workspaceURI = "<xsl:value-of select="$workspaceURI"/>";</script>
    	<script type="text/javascript">var contextPath = "<xsl:value-of select="$contextPath"/>";</script>
    	
    	<script type="text/javascript" src="{$contextPath}{$workspaceURI}/resources/js/org/ametys/repository/HomePage.i18n.js"><xsl:comment>//empty</xsl:comment></script>
    	<script type="text/javascript" src="{$contextPath}{$workspaceURI}/resources/js/org/ametys/repository/RepositoryXmlLoader.js"><xsl:comment>//empty</xsl:comment></script>
    	<script type="text/javascript" src="{$contextPath}{$workspaceURI}/resources/js/org/ametys/repository/Actions.i18n.js"><xsl:comment>//empty</xsl:comment></script>
    	<script type="text/javascript" src="{$contextPath}{$workspaceURI}/resources/js/org/ametys/repository/tree/SearchTreePanel.i18n.js"><xsl:comment>//empty</xsl:comment></script>
    	<script type="text/javascript" src="{$contextPath}{$workspaceURI}/resources/js/org/ametys/repository/tree/JCRTreePanel.i18n.js"><xsl:comment>//empty</xsl:comment></script>
    	<script type="text/javascript" src="{$contextPath}{$workspaceURI}/resources/js/org/ametys/repository/tree/ResultXmlLoader.js"><xsl:comment>//empty</xsl:comment></script>
    	<script type="text/javascript" src="{$contextPath}{$workspaceURI}/resources/js/org/ametys/repository/PropertiesFormPanel.i18n.js"><xsl:comment>//empty</xsl:comment></script>
    	<script type="text/javascript" src="{$contextPath}{$workspaceURI}/resources/js/org/ametys/repository/utils/Tooltip.js"><xsl:comment>//empty</xsl:comment></script>
    	<script type="text/javascript" src="{$contextPath}{$workspaceURI}/resources/js/org/ametys/repository/JCRViewTab.i18n.js"><xsl:comment>//empty</xsl:comment></script>
 		<script type="text/javascript" src="{$contextPath}{$workspaceURI}/resources/js/org/ametys/repository/AdminTab.i18n.js"><xsl:comment>//empty</xsl:comment></script>
    	<script type="text/javascript" src="{$contextPath}{$workspaceURI}/resources/js/org/ametys/repository/ConsoleTab.i18n.js"><xsl:comment>//empty</xsl:comment></script>
    	<script type="text/javascript" src="{$contextPath}{$workspaceURI}/resources/js/org/ametys/repository/ScriptEditor.js"><xsl:comment>//empty</xsl:comment></script>
    	
    	
    	<script type="text/javascript" src="{$contextPath}/plugins/codemirror/resources/js/codemirror.js"><xsl:comment>//empty</xsl:comment></script>
    	<script type="text/javascript" src="{$contextPath}/plugins/codemirror/resources/mode/javascript/javascript.js"><xsl:comment>//empty</xsl:comment></script>
    	
    	<link rel="stylesheet" type="text/css" href="{$contextPath}/plugins/codemirror/resources/css/codemirror.css" />
    	
    	<style>
    		.CodeMirror {
					font-size: 1.2em;
    				line-height: 1.2em;
			}
			
			.activeline {background: #f0fcff !important;}
    	</style>
    	
    	<xsl:comment>[if IE]&gt;
    		&lt;style&gt;
    			.CodeMirror {
					font-size: 1em !important;
    				line-height: 1em !important;
				}
    		&lt;/style&gt;
			&lt;![endif]</xsl:comment>
				
        <xsl:call-template name="plugins-load">
            <xsl:with-param name="scripts" select="/Workspace/views/view/scripts/file"/>
            <xsl:with-param name="debug-mode" select="$debug-mode"/>
        </xsl:call-template>
        <script type="text/javascript">
            var customTabs = [
            <xsl:for-each select="/Workspace/views/view/action">
                <xsl:value-of select="@class"/>
                <xsl:text>.getTab()</xsl:text>
                <xsl:if test="position() &gt; 1">,
</xsl:if>
            </xsl:for-each>
            ];
        </script>
    </xsl:template>                 
</xsl:stylesheet>
